#include <bits/stdc++.h>
#define int long long
#define endl '\n'
using namespace std;


signed main()
{
    ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);

    int n,k; cin >> n >> k;
    int d[k+1];
    for(int i=1; i<=k; i++) cin >> d[i];
    for(int i=1; i<=k; i++){
        int m=d[i];
        int rez=0;
        for(int j=1; j*j<=m; j++){
            if(m%j!=0) continue;
            if(j*j==m) rez^=j;
            else rez^=j^(m/j);
        }
        cout << rez << " ";
    }



    return 0;
}